import 'dart:async';
import 'package:syntax/syntax.dart';
import 'package:syntax/lexer.dart' as l;

// Tokens
class DigitToken extends Token {}


// Ast Nodes
class DigitNode extends Ast {}

program() => sx([ expression ]);
expression() =>
    zeroOrMore( sx([ Digit, expressionRest ]) );
expressionRest() => sx([ '+', Digit,  expressionRest ]);
Digit() => DIGIT <= () => new DigitToken();


T(String v) => new Token(v);
D(String v) => new DigitToken()..value = v;

main() {
  var input = '1+1+1';
  var parser = program();

  var stream = new Stream.fromIterable(input.split(''));
  var lexer = new l.Lexer(stream);
  for(final thing in lex_rules.toSet()){
    if(thing is String){
      lexer.INIT / thing / () => new Token();
    } else if (thing is l.Rule) {
      lexer.INIT.rules.add(thing);
    }
  }

  lexer.listen( (token) {
                print(token);
                parser = parser.derive(token);},
                onDone: () => print(parser.toAst()));
}
